#
# Copyright (c) 1999, 2000 University of Utah and the Flux Group.
# All rights reserved.
# This file is part of Janos.
# 
# Janos is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License, version 2, as
# published by the Free Software Foundation.
# 
# Janos is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details, in the file
# COPYING.  If that file is not present, write to the Free
# Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
# 02111-1307, USA
# 
# The University of Utah and the Flux Group requests users to
# return to flux-dist@cs.utah.edu any improvements that they make.
#

EES = 	null flowtest chantest socktest
ifneq ($(HOST_OS),solaris2.7)
EES +=	pingreply forward # cutpingreply
endif
EES_O =	$(addsufix $(EES), _o)
EES_P =	$(addsufix $(EES), _p)

all: $(EES)

all_p: $(EES_O)

all_o: $(EES_P)

### Setup the architecture-specific variables

include $(NODEOS_SRCDIR)/arch.mk


### Define some global settings for all EEs

VPATH :=	$(SRCDIR)

CPPFLAGS = 	$(ARCH_CFLAGS) -I$(NODEOS_SRCDIR)
CFLAGS += 	-g -Wall $(CPPFLAGS)

NODEOS_OBJDIR := ../src
NODEOS_LIBS := 	-u main -L$(NODEOS_OBJDIR) -lnodeos
NODEOS_LIB_DEPS := 	$(NODEOS_OBJDIR)/libnodeos.a

### Define the EEs

EE=null
EESRCS=null.c
include $(SRCDIR)/define_env.mk

EE=flowtest
EESRCS=flowtest.c
include $(SRCDIR)/define_env.mk

EE=chantest
EESRCS=chantest.c
include $(SRCDIR)/define_env.mk

EE=pingreply
EESRCS=pingreply.c
include $(SRCDIR)/define_env.mk

EE=socktest
EESRCS=socktest.c
include $(SRCDIR)/define_env.mk

EE=forward
EESRCS=forward.c
include $(SRCDIR)/define_env.mk

EE=cutpingreply
EESRCS=cutpingreply.c
EELDFLAGS=-L$(CLICK_INSTDIR)/lib -lclick
include $(SRCDIR)/define_env.mk

clean:
	rm -f .depend* core *.core *.o *.po *.oo $(EES) $(EES_O) $(EES_P) \
	      cutpingreply

distclean: clean
	rm -f GNUmakefile

install:
	@echo The example EEs will not be installed.
