/*
 * Copyright (c) 1999 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

/*
 * Resource descriptors
 */
#ifndef _NODEOS_RESOURCE_H_
#define _NODEOS_RESOURCE_H_

#include <nodeos/impl.h>
#include <nodeos/mempool.h>

/* an_flowinit_t is implementation dependent */

typedef struct {
	int		max;		/* max threads */
	int		stacksize;	/* max stack size */
	int		rate;		/* max execution rate */
	an_timespec_t	slice;		/* max time slice */
	an_sched_t	sched;		/* scheduler */
	/* an_InitFunc is now part of the FlowStartSpec */
} an_cpuspec_t;

typedef struct {
	int		npages;		/* physical pages to give to pool */
	an_mempool_t	pool;		/* associated memory pool */
} an_memspec_t;

typedef struct {
	void		*qos;
} an_netspec_t;

/* XXX compat */
#ifdef NODEOS_SPEC_COMPAT
#define an_ThreadPoolSpec an_cpuspec_t
#define an_CpuSpec an_cpuspec_t
#define an_MemSpec an_memspec_t
#endif

#endif /* _NODEOS_RESOURCE_H_ */
