#
# Copyright (c) 1999, 2000 University of Utah and the Flux Group.
# All rights reserved.
# This file is part of Janos.
# 
# Janos is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License, version 2, as
# published by the Free Software Foundation.
# 
# Janos is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details, in the file
# COPYING.  If that file is not present, write to the Free
# Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
# 02111-1307, USA
# 
# The University of Utah and the Flux Group requests users to
# return to flux-dist@cs.utah.edu any improvements that they make.
#

TARGET =	libnodeos.a
TARGET_O =	libnodeos_p.a
TARGET_P =	libnodeos_o.a

SRCS =		main.c flow.c threadpool.c thread.c credential.c resource.c \
		mempool.c mem.c channel.c packet.c synch.c demux.c \
		demux_tlist.c hnode.c misc.c if.c \
		chan_clock.c chan_eth.c chan_socket.c \
		api_credential.c api_flow.c api_thread.c api_mempool.c \
		api_channel.c api_demuxkey.c api_packet.c api_synch.c api_misc.c

include $(NODEOS_SRCDIR)/arch.mk

ifeq ($(HOST_OS),oskit)
ARCH_SRCS = 	oskit.c oskit_mem.c oskit_net.c
endif

ifeq ($(HOST_OS),linux-gnu)
ARCH_SRCS =	linux.c unix_eth.c
endif

ifeq ($(HOST_OS),solaris2.7)
ARCH_SRCS =	solaris.c unix_eth.c
endif

ifeq ($(HOST_OS),freebsd3.0)
ARCH_SRCS =	freebsd.c unix_eth.c
endif

FILES = 	$(SRCS) $(ARCH_SRCS)
FQSRCS =	$(addprefix $(SRCDIR)/,$(sort $(FILES)))

OBJS := $(patsubst %.c,%.o,$(notdir $(FQSRCS)))
POBJS := $(patsubst %.c,%.po,$(notdir $(FQSRCS)))
OOBJS := $(patsubst %.c,%.oo,$(notdir $(FQSRCS)))

CPPFLAGS = $(ARCH_CFLAGS) -I$(NODEOS_SRCDIR)
CFLAGS += -g -Wall $(CPPFLAGS)

all: $(TARGET)

opt: $(TARGET_O)

prof: $(TARGET_P)

install: all
	test -d $(INSTALL_TOPDIR) || mkdir $(INSTALL_TOPDIR)
	test -d $(INSTALL_LIBDIR) || mkdir $(INSTALL_LIBDIR)
	$(INSTALL_DATA) $(TARGET) $(INSTALL_LIBDIR)

$(TARGET): $(OBJS)
	$(AR) cru $@ $^
	$(RANLIB) $@

$(TARGET_O): $(OOBJS)
	$(AR) cru $@ $^
	$(RANLIB) $@

$(TARGET_P): $(POBJS)
	$(AR) cru $@ $^
	$(RANLIB) $@

clean:
	rm -f .depend core *.core *.o *.po *.oo $(TARGET) $(TARGET_O) $(TARGET_P)

distclean: clean
	rm -f GNUmakefile

.PHONY: depend
depend: 
	$(CC) $(CFLAGS) -E -M $(CPPFLAGS) $(FQSRCS) $(DEPINCS) > .depend

-include .depend
