/*
 * Copyright (c) 1999 The University of Utah and the Flux Group.
 * All rights reserved.
 * This file is part of Janos.
 * 
 * Janos is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License, version 2, as
 * published by the Free Software Foundation.
 * 
 * Janos is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details, in the file
 * COPYING.  If that file is not present, write to the Free
 * Software Foundation, 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA
 * 
 * The University of Utah and the Flux Group requests users to
 * return to flux-dist@cs.utah.edu any improvements that they make.
 */

/*
 * Resource descriptor
 */
#ifndef _RESOURCE_IMPL_H_
#define _RESOURCE_IMPL_H_

#include <limits.h>
#include <nodeos/resource.h>

/* XXX */
#define cpuspec_t an_cpuspec_t
#define memspec_t an_memspec_t
#define netspec_t an_netspec_t

struct resource {
	/* CPU */
	int threads;	/* number of threads */
	int cyclerate;	/* rate of CPU consumption for threads */
	int timeslice;	/* time slice of threads in usec */
	int stacksize;	/* stack size */

	/* memory */
	int ppages;	/* physical pages */

	/* network */
};
typedef struct resource resource_t;

#define RESOURCE_ALL	(INT_MAX)

/*
 * Initializes the indicated resource structure based on the given
 * CPU and memory spec.
 */
void resource_init(resource_t *res, cpuspec_t *cspec, memspec_t *mspec);

#endif /* _RESOURCE_IMPL_H_ */
